RoosterToolsMember = {}

function RoosterToolsMember:New(unitId)
    local unitId = unitId

    local member = {}
    setmetatable(member, self)
    self.__index = self

    member.guid = UnitGUID(unitId)
    member.updated = time()
    member.unitName, member.unitRealm = UnitName(unitId)
    member.specId, member.specName, _, member.specIcon, member.specRole, member.specClass = GetSpecializationInfoByID(GetInspectSpecialization(unitId))
    --        local locClass, engClass, locRace, engRace, gender, name, server = GetPlayerInfoByGUID(guid)

    member.isAFK = UnitIsAFK(unitId)
    member.isConnected = UnitIsConnected(unitId)

    member.level = UnitLevel(unitId)
    member.isVisible = UnitIsVisible(unitId)

    -- Distances
    member.withinInspectDistance = CheckInteractDistance(unitId, 1) -- 28 yards
    member.withinTradeDistance = CheckInteractDistance(unitId, 2) -- 11.11 yards
    member.withinDuelDistance = CheckInteractDistance(unitId, 3) -- 9.9 yards
    member.withinFollowDistance = CheckInteractDistance(unitId, 4) -- 28 yards

    -- Faction
    member.faction, _ = UnitFactionGroup(unitId)

    member.partyLeader = UnitIsGroupLeader(unitId)
    member.partyAssist = UnitIsGroupAssistant(unitId)
    member.isDead = UnitIsDeadOrGhost(unitId)

    member.unitIndex = UnitInRaid(unitId)

    if member.withinInspectDistance then
        member.guildName, member.guildRankName, member.guildRankIndex = GetGuildInfo(member.unitName);
    end

    return member
end

function RoosterToolsMember:ToString() 
    local buff = ""
    for k, v in pairs(self) do
        buff = buff .. k .. " -> " .. tostring(v) .. "\n"
    end

    return buff
end

function RoosterToolsMember:Overlay(prev)
    local prev = prev
    local next = self

    if (not prev) then
        return next
    end

    -- Carry forward non-nil fields
    for k, v in pairs(prev) do
        if (not next[k] and type(next[k]) ~= "boolean") then
            next[k] = prev[k]
        end
    end

    return next
end

function RoosterToolsMember:RaidInfo(raidIndex)
    local member = self
    if (raidIndex) then
        member.name, member.rank, member.subgroup, member.level, member.class,
        member.fileName, member.zone, member.online, member.isDead, member.role, member.isML = GetRaidRosterInfo(raidIndex)
    end

    return member
end
