local rt = RoosterTools
local db = {}

local defaultDb = {
    partyGuid = nil,
    config = {
        raid = {
            minGuildMembers = 10
        },
        party = {
            minGuildMembers = 4
        }
    },
    characters = {},
    groups = {},
    mains = {},
    sync = {},
    aliases = {},
    debug = false,
}

RoosterToolsDBConn = {}

function RoosterToolsDBConn:SelectCharacterByName(name) 
    for k, v in pairs(db.characters) do
        if (string.lower(v.unitName) == string.lower(name)) then
            return k, v
        end
    end

    return nil
end

function RoosterToolsDBConn:SelectGuildRaidGroups() 
    local t = {}
    
    for k, v in pairs(db.groups) do
        if (v.guildGroupTime and v.type == "raid") then
            t[k] = v
        end
    end

    return t
end

function RoosterToolsDBConn:SelectGuildGroups() 
    local t = {}
    
    for k, v in pairs(db.groups) do
        if (v.guildGroupTime) then
            t[k] = v
        end
    end

    return t
end

function RoosterToolsDBConn:OnInitialize() 
    db = RoosterToolsDB

     -- Init the db if it hasn't been used.
     if (not db) then
        RoosterToolsDB = defaultDb
        db = RoosterToolsDB
    end

    if (not db.aliases) then
        -- DB Upgrade
        db.aliases = {}
    end

    if (not db.debug) then
        db.debug = false
    end
end
